/*******************************************************************************
 tapt.c

 ADSK 2017-09-21 New file
*******************************************************************************/ 

#include "lqt_private.h"
#include <string.h>


void quicktime_tapt_init(quicktime_tapt_t *tapt)
{
  memset( tapt, 0, sizeof( quicktime_tapt_t ) );
}

static void read_aper(quicktime_t *file, quicktime_aperture_t *aper)
{
  aper->version = quicktime_read_char(file);
  aper->flags = quicktime_read_int24(file);
  aper->width = quicktime_read_fixed32(file);
  aper->height = quicktime_read_fixed32(file);
}

void quicktime_read_tapt(quicktime_t *file, quicktime_tapt_t *tapt,
                        const quicktime_atom_t *tapt_atom)
{
  quicktime_atom_t leaf_atom;

  while(quicktime_position(file) < tapt_atom->end)
  {
    quicktime_atom_read_header(file, &leaf_atom);

    if(quicktime_atom_is(&leaf_atom, "clef"))
      read_aper(file, &(tapt->clef));
    else if(quicktime_atom_is(&leaf_atom, "prof"))
      read_aper(file, &(tapt->prof));
    else if(quicktime_atom_is(&leaf_atom, "enof"))
      read_aper(file, &(tapt->enof));
    else
      quicktime_atom_skip(file, &leaf_atom);
  }
}

